//---------------------------------------------------------------------------

#ifndef Win_RT_FormH
#define Win_RT_FormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <IdBaseComponent.hpp>
#include <IdComponent.hpp>
#include <IdUDPBase.hpp>
#include <IdUDPClient.hpp>
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
static const int HMAX=30;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
class TRtTestThread:public TThread
{
private:
protected:
	virtual void __fastcall Execute(void);
public:
	__fastcall TRtTestThread(void);

  int RunCount;
  double RunPeriod;
  double MaxTime;
  int HSec[HMAX];

  class THighResTimer *HRT;
  class TWinRealtimeForm *MF;
};

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// high resolution timer object
class THighResTimer: public TObject
{
private:
  LARGE_INTEGER t0,t1,f;
  double et,last_dt;
  bool na;
protected:
public:
	__fastcall THighResTimer(void);
  void __fastcall HighResReset(void);   // reset timer
  double __fastcall HighResTime(void);	// elapsed time in seconds
};

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
class TWinRealtimeForm : public TForm
{
__published:	// IDE-managed Components
  TComboBox *ClockRate;
  TLabel *Label1;
  TMemo *Memo1;
  TButton *StartButton;
  TButton *StopButton;
  TEdit *ActualRate;
  TLabel *Label2;
  TTimer *Timer1;
  TStatusBar *StatusBar1;
  TEdit *UDP_Host;
  TCheckBox *RunUDP;
  TIdUDPClient *IdUDPClient1;
  TComboBox *PLevel;
  TLabel *Label3;
  TLabel *Label4;
  TComboBox *TLevel;
  void __fastcall FormShow(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall StartButtonClick(TObject *Sender);
  void __fastcall StopButtonClick(TObject *Sender);
  void __fastcall Timer1Timer(TObject *Sender);
private:	// User declarations
  friend TRtTestThread;

  int ClockRateSet;
  
  TRtTestThread *RT_Thread;
public:		// User declarations
  __fastcall TWinRealtimeForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TWinRealtimeForm *WinRealtimeForm;
//---------------------------------------------------------------------------
#endif
