//
// This program and source are subject to the GPL Open Source License
// Please refer to the following document
// http://www.borland.com/kylix/gpl.html

//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "Unit1.h"
#include "cpp_lib.h"
#ifdef __linux__
#include <sys/resource.h>
#include <sched.h>
#include <sys/mman.h>
#endif
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TForm1 *Form1;
//----------------------------------------------------------------------------
const int NBigArray=16*1024*1024;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
  DataList=new TList();
  LRT=new TLowResTimer();
  Edit1->Text="";
  Edit2->Text="";
  Edit3->Text="";
  Edit4->Text="";
  Edit5->Text="";
  Memo1->Clear();

  Timer1->Enabled=true;


  #ifdef __linux__
  TSchedParam sp;

  def_prio=sched_get_priority_min(SCHED_OTHER);
  max_prio=sched_get_priority_max(SCHED_RR);
  min_prio=sched_get_priority_min(SCHED_RR);

  sp.sched_priority=def_prio;
  sched_setscheduler(0,SCHED_OTHER,&sp);
  setpriority(PRIO_PROCESS,getpid(),-20);

  // N/A in Linux
  SetWorkingSet->Checked=false;
  SetWorkingSet->Enabled=false;
  
  // disable these to avoid lockups, enable at your risk
  // locking more memory than you have can cause Linux to freeze
  LockMemory->Checked=false;
  LockMemory->Enabled=false;
  #endif

  #ifdef __WIN32__
  SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
  #endif

  // can cause lockups, enable at your own risk
  RunRealtime->Checked=false;
  RunRealtime->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormHide(TObject *Sender)
{
  Timer1->Enabled=false;
  for (int i=0;i<DataList->Count;i++)
  {
    unsigned char *BA=(unsigned char *)DataList->Items[i];
    DataList->Items[i]=NULL;
    delete[] BA;
  }
  delete DataList;
  delete LRT;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  unsigned char *BA=new unsigned char[NBigArray];
  for (int i=0;i<NBigArray;i++) BA[i]=0;
  DataList->Add(BA);
  Edit1->Text=FloatToStrF(DataList->Count*NBigArray,ffNumber,20,0);
  Cycles=0;
  Edit4->Text="";
  Edit5->Text="";
  if (SetWorkingSet->Checked)
  {
    #ifndef __linux__
    DWORD MinSize,MaxSize;
    DWORD SetSize=NBigArray*DataList->Count+2*1024*1024;
    GetProcessWorkingSetSize(GetCurrentProcess(),&MinSize,&MaxSize);
    if (!SetProcessWorkingSetSize(GetCurrentProcess(),SetSize,SetSize))
    {
      Memo1->Lines->Add("SetProcessWorkingSetSize failure!");
    }
    #endif
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  if (DataList->Count<=0) return;
  unsigned char *BA=(unsigned char *)DataList->Items[0];
  DataList->Items[0]=NULL;
  delete[] BA;
  DataList->Pack();
  Edit1->Text=FloatToStrF(DataList->Count*NBigArray,ffNumber,20,0);
  Cycles=0;
  Edit4->Text="";
  Edit5->Text="";
  if (SetWorkingSet->Checked)
  {
    #ifndef __linux__
    DWORD MinSize,MaxSize;
    DWORD SetSize=NBigArray*DataList->Count+2*1024*1024;
    GetProcessWorkingSetSize(GetCurrentProcess(),&MinSize,&MaxSize);
    if (!SetProcessWorkingSetSize(GetCurrentProcess(),SetSize,SetSize))
    {
      Memo1->Lines->Add("SetProcessWorkingSetSize failure!");
    }
    #endif
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  Memo1->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  static bool InTimer=false;

  if (InTimer) return;

  InTimer=true;

  LRT->ResetTimer();

  for (int i=0;i<DataList->Count;i++)
  {
    unsigned char *BA=(unsigned char*)DataList->Items[i];
    for (int j=0;j<NBigArray;j++)
    {
      BA[j++]++;
      BA[j++]++;
      BA[j++]++;
      BA[j++]++;
      BA[j++]++;
      BA[j++]++;
      BA[j++]++;
      BA[j]++;
    }
    Cycles++;
    Edit2->Text=IntToStr(Cycles)+"-"+IntToStr(i);
    double T=LRT->TimeSeconds();
    Edit3->Text=FloatToStrF(T,ffFixed,20,3);
    const unsigned int SCycle=DataList->Count*2;
    if (Cycles==SCycle)
    {
      NTime=0;
      TTime=0;
      MinTime=60.0;
      MaxTime=0.0;
      AveTime=0.0;
      CacheTime=0.0;
    }
    else if (Cycles>SCycle)
    {
      if (T>MaxTime)
      {
        MaxTime=T;
        Edit4->Text=FloatToStrF(MaxTime,ffFixed,20,3);
      }
      if (T<MinTime) MinTime=T;
      const int STime=8;
      if (NTime<STime)
      {
        NTime++;
        TTime+=T;
        if (NTime==STime)
        {
          AveTime=TTime/NTime;
        }
      }
      else
      {
        double ExcessTime=T-AveTime;
        // more than 25% increase gets counted as excess time
        if (ExcessTime>AveTime*0.25)
        {
          CacheTime+=ExcessTime;
          Edit5->Text=FloatToStrF(CacheTime,ffFixed,20,3);
        }
      }
    }
    Application->ProcessMessages();
    // also sleep a little to allow foregound to run
    // otherwise, realtime will freeze system
    if (RunRealtime->Checked) Sleep(10);
    LRT->ResetTimer();
  }

  InTimer=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
  MaxTime=0.0;
  Edit4->Text="";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
  CacheTime=0.0;
  Edit5->Text="";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RunRealtimeClick(TObject *Sender)
{
  #ifdef __linux__
  TSchedParam sp;
  int EC=0;
  if (RunRealtime->Checked)
  {
    sp.sched_priority=min_prio;
    EC=sched_setscheduler(0,SCHED_RR,&sp);
  }
  else
  {
    sp.sched_priority=def_prio;
    EC=sched_setscheduler(0,SCHED_OTHER,&sp);
    setpriority(PRIO_PROCESS,getpid(),-20);
  }
  if (EC!=0) Memo1->Lines->Add("sched_setscheduler error "+IntToStr(EC));
  #endif

  #ifdef __WIN32__
  if (RunRealtime->Checked)
  {
    SetPriorityClass(GetCurrentProcess(),REALTIME_PRIORITY_CLASS);
    SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);
  }
  else
  {
    SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS);
    SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
  }
  #endif
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LockMemoryClick(TObject *Sender)
{
  #ifdef __linux__
  int EC=0;
  if (LockMemory->Checked) EC=mlockall(MCL_CURRENT | MCL_FUTURE);
  else EC=munlockall();
  if (EC!=0) Memo1->Lines->Add("mlockall error "+IntToStr(EC));
  #endif

  #ifdef __WIN32__
  // not easy or possible in Win32
  Memo1->Lines->Add("n/a");
  #endif
}
//---------------------------------------------------------------------------

