//
// This program and source are subject to the GPL Open Source License
// Please refer to the following document
// http://www.borland.com/kylix/gpl.html

//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "DiskTestForm.h"
#include "cpp_lib.h"
#ifdef __linux__
#include <sys/resource.h>
#include <sched.h>
#include <sys/mman.h>
#endif
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TForm1 *Form1;
//----------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
  LRT=new TLowResTimer();
  FileSizeTBChange(NULL);
  BufferSizeTBChange(NULL);
  Edit1->Text="";
  Edit2->Text="";
  Edit3->Text="";
  Edit4->Text="";
  Edit5->Text="";
  FilePath=ExtractFilePath(Application->ExeName);
  Edit5->Text=FilePath;

  #ifdef __linux__
  TSchedParam sp;

  def_prio=sched_get_priority_min(SCHED_OTHER);
  max_prio=sched_get_priority_max(SCHED_RR);
  min_prio=sched_get_priority_min(SCHED_RR);

  sp.sched_priority=def_prio;
  sched_setscheduler(0,SCHED_OTHER,&sp);
  setpriority(PRIO_PROCESS,getpid(),-20);
  #endif

  #ifdef __WIN32__
  SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
  #endif
  
  // disable realtime to avoid lockups (enable at your own risk)
  // this usually won't happen as program waits for I/O
  RunRealtime->Checked=false;
  RunRealtime->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormHide(TObject *Sender)
{
  delete LRT;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RunTestButtonClick(TObject *Sender)
{
  #ifdef __linux__
  if ((FilePath.Length()>0) && (FilePath[FilePath.Length()]!='/'))
  FilePath=FilePath+WideString('/');
  AnsiString FileName=AnsiString(FilePath)+"Disk_Test_File";
  #endif

  #ifdef __WIN32__
  if ((FilePath.Length()>0) && (FilePath[FilePath.Length()]!='\\'))
  FilePath=FilePath+'\\';
  AnsiString FileName=FilePath+"Disk_Test_File";
  #endif

  TFileStream *FS=new TFileStream(FileName,fmCreate);
  unsigned char *Buffer=new unsigned char[BufferSize];

  // use try-finally in case something goes wrong with the file
  
  __try
  {
    ExitLoop=false;
    RunTestButton->Enabled=false;
    CancelButton->Enabled=true;
    Button1->Enabled=false;
    FileSizeTB->Enabled=false;
    BufferSizeTB->Enabled=false;

    for (int i=0;i<BufferSize;i++) Buffer[i]=i;
    bool WriteMode=true;

    TotalWrite=0.0;
    WriteRate=0.0;
    TotalRead=0.0;
    ReadRate=0.0;
    LRT->ResetTimer();
    double T;
    Timer1->Enabled=true;

    while (!ExitLoop)
    {
      Application->ProcessMessages();
      if (WriteMode)
      {
        FS->Write(Buffer,BufferSize);
        TotalWrite+=BufferSize;
        //TotalWrite=FS->Position;
        T=LRT->TimeSeconds();
        if (T>0.0)
        {
          WriteRate=TotalWrite/T;
        }
        if (TotalWrite>=FileSize)
        {
          FS->Position=0;
          WriteMode=false;
          LRT->ResetTimer();
          TotalRead=0.0;
        }
      }
      else
      {
        int RB=FS->Read(Buffer,BufferSize);
        TotalRead+=BufferSize;
        //TotalRead=FS->Position;
        T=LRT->TimeSeconds();
        if (T>0.0)
        {
          ReadRate=TotalRead/T;
        }
        if (RB<=0)
        {
          FS->Position=0;
          FS->Size=0;
          WriteMode=true;
          LRT->ResetTimer();
          TotalWrite=0.0;
        }
      }
    }
  }
  __finally
  {
    Timer1->Enabled=false;

    RunTestButton->Enabled=true;
    CancelButton->Enabled=false;
    Button1->Enabled=true;
    FileSizeTB->Enabled=true;
    BufferSizeTB->Enabled=true;

    delete FS;
    delete[] Buffer;
    DeleteFile(FileName);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  Edit1->Text=FloatToStrF(TotalWrite,ffNumber,20,0);
  Edit2->Text=FloatToStrF(WriteRate,ffNumber,20,0);
  Edit3->Text=FloatToStrF(TotalRead,ffNumber,20,0);
  Edit4->Text=FloatToStrF(ReadRate,ffNumber,20,0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CancelButtonClick(TObject *Sender)
{
  ExitLoop=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FileSizeTBChange(TObject *Sender)
{
  switch (FileSizeTB->Position)
  {
    default:
    case 0: FileSize=1024.0*32.0; break;
    case 1: FileSize=1024.0*64.0; break;
    case 2: FileSize=1024.0*512.0; break;
    case 3: FileSize=1024.0*1024.0; break;
    case 4: FileSize=1024.0*1024.0*16.0; break;
    case 5: FileSize=1024.0*1024.0*32.0; break;
    case 6: FileSize=1024.0*1024.0*64.0; break;
    case 7: FileSize=1024.0*1024.0*128.0; break;
    case 8: FileSize=1024.0*1024.0*256.0; break;
    case 9: FileSize=1024.0*1024.0*512.0; break;
    case 10: FileSize=1024.0*1024.0*1024.0; break;
    case 11: FileSize=1024.0*1024.0*1024.0*2.0; break;
    case 12: FileSize=1024.0*1024.0*1024.0*4.0; break;
  }
  FileSizeBox->Caption="File Size: "+FloatToStrF(FileSize,ffNumber,20,0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BufferSizeTBChange(TObject *Sender)
{
  switch (BufferSizeTB->Position)
  {
    default:
    case 0: BufferSize=1024*1; break;
    case 1: BufferSize=1024*2; break;
    case 2: BufferSize=1024*4; break;
    case 3: BufferSize=1024*8; break;
    case 4: BufferSize=1024*16; break;
    case 5: BufferSize=1024*32; break;
    case 6: BufferSize=1024*64; break;
    case 7: BufferSize=1024*128; break;
    case 8: BufferSize=1024*256; break;
    case 9: BufferSize=1024*512; break;
    case 10: BufferSize=1024*1024; break;
  }
  BufferSizeBox->Caption="Buffer Size: "+FloatToStrF(BufferSize,ffNumber,20,0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  if(OpenDialog1->Execute()){
  	#ifdef __linux__
    FilePath=ExtractFilePath(AnsiString(OpenDialog1->FileName));
    #endif

    #ifdef __WIN32__
    FilePath=ExtractFilePath(OpenDialog1->FileName);
  	#endif

    Edit5->Text=FilePath;
  };
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	CanClose=!CancelButton->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RunRealtimeClick(TObject *Sender)
{
  #ifdef __linux__
  TSchedParam sp;
  if (RunRealtime->Checked)
  {
    sp.sched_priority=min_prio;
    sched_setscheduler(0,SCHED_RR,&sp);
  }
  else
  {
    sp.sched_priority=def_prio;
    sched_setscheduler(0,SCHED_OTHER,&sp);
    setpriority(PRIO_PROCESS,getpid(),-20);
  }
  #endif

  #ifdef __WIN32__
  if (RunRealtime->Checked)
  {
    SetPriorityClass(GetCurrentProcess(),REALTIME_PRIORITY_CLASS);
    SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);
  }
  else
  {
    SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS);
    SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
  }
  #endif
}
//---------------------------------------------------------------------------

