//
// This program and source are subject to the GPL Open Source License
// Please refer to the following document
// http://www.borland.com/kylix/gpl.html

//---------------------------------------------------------------------------
#pragma inline
#include <clx.h>
#pragma hdrstop

#include <math.h>
#include "SMP_ATask.h"
#include "cpp_lib.h"
#include "SMP_Test_Form.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
void __fastcall TSMP_AThread::Execute(void)
{
	int NY;
	const int NX=1024;
	const int OType=SMPTestForm->Operation->ItemIndex;

	switch (SMPTestForm->MemorySize->ItemIndex) {
		case 0: NY=64; break;
		case 1: NY=128; break;
		case 2: NY=256; break;
		case 3: NY=512; break;
		case 4: NY=1024; break;
		case 5: NY=2048; break;
		case 6: NY=4096; break;
		case 7: NY=8192; break;
		default: NY=64;
	}

	const int NBUF=NY*NX;
	volatile unsigned char *buf=new unsigned char [NBUF];
	volatile register double r1;
	for (int i=0;i<NBUF;i++) buf[i]=(unsigned char)i;
	int *Histogram=new int [256];
  LRT=new TLowResTimer();
  int NR=0;

	while (!Terminated) {
		switch (OType) {
			case 0:
				for (int i=0;i<NY;i++)
				r1=sin(0.025*i);
				break;
			case 1:
				asm {
					mov edx,NBUF
					mov ecx,buf
					step1:

					mov al,byte ptr [ecx]
					inc ecx
					dec edx

					mov al,byte ptr [ecx]
					inc ecx
					dec edx

					mov al,byte ptr [ecx]
					inc ecx
					dec edx

					mov al,byte ptr [ecx]
					inc ecx
					dec edx

					mov al,byte ptr [ecx]
					inc ecx
					dec edx

					mov al,byte ptr [ecx]
					inc ecx
					dec edx

					mov al,byte ptr [ecx]
					inc ecx
					dec edx

					mov al,byte ptr [ecx]
					inc ecx
					dec edx

					jnz step1
				}
				break;
			case 2:
				asm {
					mov al,0
					mov edx,NBUF
					mov ecx,buf
					step2:

					mov byte ptr [ecx],al
					inc ecx
					dec edx

					mov byte ptr [ecx],al
					inc ecx
					dec edx

					mov byte ptr [ecx],al
					inc ecx
					dec edx

					mov byte ptr [ecx],al
					inc ecx
					dec edx

					mov byte ptr [ecx],al
					inc ecx
					dec edx

					mov byte ptr [ecx],al
					inc ecx
					dec edx

					mov byte ptr [ecx],al
					inc ecx
					dec edx

					mov byte ptr [ecx],al
					inc ecx
					dec edx

					jnz step2
				}
				break;
			case 3:
				asm {
					mov edx,NBUF
					mov ecx,buf
					step3:

					inc byte ptr [ecx]
					inc ecx
					dec edx

					inc byte ptr [ecx]
					inc ecx
					dec edx

					inc byte ptr [ecx]
					inc ecx
					dec edx

					inc byte ptr [ecx]
					inc ecx
					dec edx

					inc byte ptr [ecx]
					inc ecx
					dec edx

					inc byte ptr [ecx]
					inc ecx
					dec edx

					inc byte ptr [ecx]
					inc ecx
					dec edx

					inc byte ptr [ecx]
					inc ecx
					dec edx

					jnz step3
				}
				break;
			case 4:
				asm {
					mov edx,256
					mov ecx,Histogram
					step4a:
					mov dword ptr [ecx],0
          add ecx,4
					dec edx
					jnz step4a

					mov edx,NBUF
					mov ecx,buf
					mov ebx,Histogram
					step4:

          xor eax,eax
					mov al,byte ptr [ecx]
          shl eax,2
					inc dword ptr [ebx+eax]
					inc ecx
					dec edx

          xor eax,eax
					mov al,byte ptr [ecx]
          shl eax,2
					inc dword ptr [ebx+eax]
					inc ecx
					dec edx

          xor eax,eax
					mov al,byte ptr [ecx]
          shl eax,2
					inc dword ptr [ebx+eax]
					inc ecx
					dec edx

          xor eax,eax
					mov al,byte ptr [ecx]
          shl eax,2
					inc dword ptr [ebx+eax]
					inc ecx
					dec edx

          xor eax,eax
					mov al,byte ptr [ecx]
          shl eax,2
					inc dword ptr [ebx+eax]
					inc ecx
					dec edx

          xor eax,eax
					mov al,byte ptr [ecx]
          shl eax,2
					inc dword ptr [ebx+eax]
					inc ecx
					dec edx

          xor eax,eax
					mov al,byte ptr [ecx]
          shl eax,2
					inc dword ptr [ebx+eax]
					inc ecx
					dec edx

          xor eax,eax
					mov al,byte ptr [ecx]
          shl eax,2
					inc dword ptr [ebx+eax]
					inc ecx
					dec edx

					jnz step4
				}
				break;
			case 5:
				asm {
					mov edx,NBUF
					mov ecx,buf
					mov bl,128
					step5:

					cmp byte ptr [ecx],bl
					jg step5a
					mov byte ptr [ecx],0
					jmp step5b
					step5a:
					mov byte ptr [ecx],255
					step5b:
					inc ecx
					dec edx

					cmp byte ptr [ecx],bl
					jg step5c
					mov byte ptr [ecx],0
					jmp step5d
					step5c:
					mov byte ptr [ecx],255
					step5d:
					inc ecx
					dec edx

					cmp byte ptr [ecx],bl
					jg step5e
					mov byte ptr [ecx],0
					jmp step5f
					step5e:
					mov byte ptr [ecx],255
					step5f:
					inc ecx
					dec edx

					cmp byte ptr [ecx],bl
					jg step5g
					mov byte ptr [ecx],0
					jmp step5h
					step5g:
					mov byte ptr [ecx],255
					step5h:
					inc ecx
					dec edx

					jnz step5
				}
				break;
		}
		NR++;
		double dt=LRT->TimeSeconds();
		if (dt>=1.0) {
      LRT->ResetTimer();
			NumRun=NR/dt;
			NR=0;
			if (SMPTestForm->Operation->ItemIndex>0)
      BytesPerSecond=NumRun*NBUF/dt;
		}
	}

	delete[] Histogram;
	delete[] buf;
  delete LRT;
}
//---------------------------------------------------------------------------
__fastcall TSMP_AThread::TSMP_AThread(void)
	:TThread(true)
{
	FreeOnTerminate=false;
}
//---------------------------------------------------------------------------

