//
// This program and source are subject to the GPL Open Source License
// Please refer to the following document
// http://www.borland.com/kylix/gpl.html

//---------------------------------------------------------------------------
#include <clx.h>
#pragma hdrstop

#include <math.h>
#include "SMP_CTask.h"
#include "cpp_lib.h"
#include "SMP_Test_Form.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
void __fastcall TSMP_CThread::Execute(void)
{
	int NY;
	const int NX=1024;
	const int OType=SMPTestForm->Operation->ItemIndex;

	switch (SMPTestForm->MemorySize->ItemIndex) {
		case 0: NY=64; break;
		case 1: NY=128; break;
		case 2: NY=256; break;
		case 3: NY=512; break;
		case 4: NY=1024; break;
		case 5: NY=2048; break;
		case 6: NY=4096; break;
		case 7: NY=8192; break;
		default: NY=64;
	}

	const int NBUF=NY*NX;
	volatile unsigned char *buf=new unsigned char [NBUF];
	volatile register double r1;
	for (int i=0;i<NBUF;i++) buf[i]=(unsigned char)i;
	int *Histogram=new int [256];
  LRT=new TLowResTimer();
  int NR=0;
  volatile unsigned char c;
  volatile int ic;

	while (!Terminated) {
		switch (OType) {
			case 0:
				for (int i=0;i<NY;i++)
				r1=sin(0.025*i);
				break;
			case 1:
				for (int i=0;i<NBUF;i++)
        {
          c=buf[i++];
          c=buf[i++];
          c=buf[i++];
          c=buf[i++];
          c=buf[i++];
          c=buf[i++];
          c=buf[i++];
          c=buf[i];
				}
        break;
			case 2:
				for (int i=0;i<NBUF;i++)
        {
          buf[i]=(unsigned char)i++;
				  buf[i]=(unsigned char)i++;
				  buf[i]=(unsigned char)i++;
				  buf[i]=(unsigned char)i++;
				  buf[i]=(unsigned char)i++;
				  buf[i]=(unsigned char)i++;
				  buf[i]=(unsigned char)i++;
				  buf[i]=(unsigned char)i;
				}
        break;
			case 3:
				for (int i=0;i<NBUF;i++)
        {
          buf[i++]++;
				  buf[i++]++;
				  buf[i++]++;
				  buf[i++]++;
				  buf[i++]++;
				  buf[i++]++;
				  buf[i++]++;
				  buf[i]++;
				}
        break;
			case 4:
				for (int i=0;i<256;i++) Histogram[i]=0;
				for (int i=0;i<NBUF;i++)
				{
          Histogram[buf[i++]]++;
          Histogram[buf[i++]]++;
          Histogram[buf[i++]]++;
          Histogram[buf[i]]++;
				}
        break;
			case 5:
				for (int i=0;i<NBUF;i++)
				{
          if (buf[i]>128) buf[i]=255;
          else buf[i]=0;
          i++;
          if (buf[i]>128) buf[i]=255;
          else buf[i]=0;
          i++;
          if (buf[i]>128) buf[i]=255;
          else buf[i]=0;
          i++;
          if (buf[i]>128) buf[i]=255;
          else buf[i]=0;
				}
        break;
		}
		NR++;
		double dt=LRT->TimeSeconds();
		if (dt>=1.0) {
      LRT->ResetTimer();
			NumRun=NR/dt;
			NR=0;
			if (SMPTestForm->Operation->ItemIndex>0)
      BytesPerSecond=NumRun*NBUF/dt;
		}
	}

	delete[] Histogram;
	delete[] buf;
  delete LRT;
}
//---------------------------------------------------------------------------
__fastcall TSMP_CThread::TSMP_CThread(void)
	:TThread(true)
{
	FreeOnTerminate=false;
}
//---------------------------------------------------------------------------

